FROM rust:1.91-bookworm AS base

#
# MARK: Build
#
FROM base AS build

RUN apt-get update && \
	apt-get install -y --no-install-recommends \
	ca-certificates wget unzip \
	&& rm -rf /var/lib/apt/lists/*

WORKDIR /app/rust
COPY . .
RUN cargo build --release --workspace
RUN cargo test --release --workspace

#
# MARK: Release
#
FROM debian:bookworm@sha256:00cd074b40c4d99ff0c24540bdde0533ca3791edcdac0de36d6b9fb3260d89e2 AS deploy

WORKDIR /app

RUN apt-get update && \
	apt-get install -y --no-install-recommends \
	ca-certificates \
	&& rm -rf /var/lib/apt/lists/*

COPY --from=build \
	/app/rust/target/release/webpage \
	/app/bin/

ENV PATH="/app/bin:$PATH"
ENV RUST_BACKTRACE=full

ENTRYPOINT [""]
